/* //////////////////////////////////////////////////////////////////////////////////////
** File:      wrc.c
*/                                  
#define  Ver "wrc ver 0.2\r       by Guiott"
/* Autore:    Guido Ottaviani-->g.ottaviani@mediaprogetti.it<--
** Descrizione:Gestione telecomando a infrarossi multiplo   
**              
///////////////////////////////////////////////////////////////////////////////////////*/

// include standard
#include <p18f452.h>
#include <stdlib.h>
#include <math.h>
#include <pwm.h>
#include <delays.h>
#include <usart.h>
#include <stdio.h>
#include "wrc_definitions.h"// contiene: definizioni, prototipi funzioni
#include "wrc_settings.h"	// contiene: settings

void main (void)	// ==========
{
INTCONbits.GIEH=0;	// disabilitati tutti gli interrupt high
INTCONbits.GIEL=0;	// disabilitati tutti gli interrupt low	

Settings(); // imposta porte e registri (settings.h)

LedOff();	// spegne tutti i led IR
RC_TEST_FLAG = 0;
DELAY100MS;

while (1) // main loop
{
RCerr = 0;
RX_FLAG = 0;
RXpoint = 0;

INTCONbits.GIEH=1;	// abilita interrupt High
INTCONbits.GIEL=1;	// abilita interrupt Low

while (!RX_FLAG && !RC_TEST_FLAG)	// idle in attesa di comandi	
{
Nop();	
}
if (RC_TEST_FLAG)
{
	RCtest();// trasmette di continuo su tutti i canali
}
else
{
	RC();	// trasmette comando ricevuto
}
}
}

/* Funzioni ***************************************************************************/
void RCtest(void)
{
// invia il dato "0" a tutti i led con tutti i protocolli in sequenza
	for (RC_LED_NUM = 0; RC_LED_NUM < 15; RC_LED_NUM ++)
	{
		for (RC_PROT = 6; RC_PROT <=7; RC_PROT ++)
		{
			RC_DATA = 0;
			if (RC_PROT == 6)	//  
			{
				RC_ADDR = 39; // DDT Philips
			}
			else
			{
				RC_ADDR = 0; // SKY
			}
			printf("RC_LED_NUM: %d - RC_PROT: %d\n\r", RC_LED_NUM, RC_PROT);
			RC();
		}
	}
}
void RC(void)
{
	if (!RCerr)	// skip se timeout o RX error 
	{
		LedOff(); 				// spegne tutti i led
		if (!LedSelect(RC_LED_NUM)) 	// seleziona il canale da gestire
		{
			if (RC_LED_NUM == 'd') // debug mode trasforma ASCII in numerico
			{
				RC_PROT -= 0x30;
				RC_DATA -= 0x30;
			}
			switch (RC_PROT)
	      	{   
	         	case 6:// RC6
	         		RC_MODE = 0;
					RC6();	
	         		break;	
	         	case 7:// RC6 SKY
	         		RC_MODE = 6;
					RC6();	
	         		break;
	         	default:
	         		RCerr=4;
	         		break;
	       	} 
	     }
	     else
	     {
		     RCerr=3;
		 }
	}	
	
	if (RC_LED_NUM == 'd') // debug mode trasforma numerico in ASCII 
		{
			RCerr += 0x30;
		}
		
	WriteUSART(RCerr);
}

void RC6()
{
	LED1=1;		// segnalazione	
	RC6Header(1);		
	RC6Dat();	// invia i campi control e information
	LedOff();		
	RC6Tick(6); // "Signal Free" almeno 2,66ms senza segnale
	LED1=0;
	DELAY100MS;
}
void LedOff(void)
// spegne tutti i led IR
{
	PORTA |= 0b00111000;
	PORTC |= 0b00000101;
	PORTD |= 0b11111111;
	PORTE |= 0b00000111;
}

unsigned char LedSelect(unsigned char LedNum)
// imposta le variabili relative al led da gestire
{
/* maschere per il set (OR) o il clear (AND) del singolo bit
   PORTx & IRxYon  -> clear del bit -> led acceso
   PORTx | IRxYoff -> set   del bit -> led spento
*/
switch (LedNum)
      {   
         case 0:// A4 IR OUT 0
         		Port  = & PORTA;
				MaskOn  = 0b11101111;
				MaskOff = 0b00010000;	
         		break;           
 		 case 1:// A5 IR OUT 1
         		Port  = & PORTA;
				MaskOn  = 0b11011111;
				MaskOff = 0b00100000;	
         		break; 
         case 2:// C0 IR OUT 2
         		Port  = & PORTC;
				MaskOn  = 0b11111110;
				MaskOff = 0b00000001;	
         		break;
         case 3:// C2 IR OUT 3
         		Port  = & PORTC;
				MaskOn  = 0b11111101;
				MaskOff = 0b00000010;	
         		break;
         case 4:// D0 IR OUT 4
         		Port  = & PORTD;
				MaskOn  = 0b11111110;
				MaskOff = 0b00000001;	
         		break;
         case 5:// D1 IR OUT 5
         		Port  = & PORTD;
				MaskOn  = 0b11111101;
				MaskOff = 0b00000010;	
         		break;
         case 6:// D2 IR OUT 6
           		Port  = & PORTD;
				MaskOn  = 0b11111011;
				MaskOff = 0b00000100;	
         		break; 
         case 7:// D3 IR OUT 7
         		Port  = & PORTD;
				MaskOn  = 0b11110111;
				MaskOff = 0b00001000;	
         		break;
         case 8:// D4 IR OUT 8
         		Port  = & PORTD;
				MaskOn  = 0b11101111;
				MaskOff = 0b00010000;	
         		break;
         case 9:// D5 IR OUT 9
         		Port  = & PORTD;
				MaskOn  = 0b11011111;
				MaskOff = 0b00100000;	
         		break;
         case 10:// D6 IR OUT 10
         		Port  = & PORTD;
				MaskOn  = 0b10111111;
				MaskOff = 0b01000000;	
         		break;
         case 11:// D7 IR OUT 11
         		Port  = & PORTD;
				MaskOn  = 0b01111111;
				MaskOff = 0b10000000;	
         		break;
         case 12:// E0 IR OUT 12
         		Port  = & PORTE;
				MaskOn  = 0b111111110;
				MaskOff = 0b000000001;	
         		break;
         case 13:// E1 IR OUT 13
         		Port  = & PORTE;
				MaskOn  = 0b111111101;
				MaskOff = 0b000000010;	
         		break;
         case 14:// E2 IR OUT 14
         		Port  = & PORTE;
				MaskOn  = 0b111111011;
				MaskOff = 0b000000100;	
         		break;
         case 15:// A3 IR OUT 15
         		Port  = & PORTA;
				MaskOn  = 0b11110111;
				MaskOff = 0b00001000;	
         		break;
         case 'd':// A3 IR OUT 1 modalita' debug "d"
         		Port  = & PORTA;
				MaskOn  = 0b11110111;
				MaskOff = 0b00001000;	
         		break;
         case 'h':// help "h"
         		printf("\n\n\r================================================\n\r");
         		printf("h = help\n\r");
         		printf("d = debug, converte in ASCII\n\r");
         		printf("t = test\n\n\r");
         		printf("Stringa di comandi (RS232 19.200 N 8 1):\n\r");
				printf(" 0-canale (0 - 15)\n\r");
				printf(" 1-protocollo\n\r");
				printf("    6-RC6\n\r");
				printf("    7-RC6 SKY\n\r");
				printf(" 2-indirizzo\n\r");
				printf(" 3-dato\n\n\r");
				printf("Errori:\n\r");
				printf(" 0 = OK\n\r");
				printf(" 1 = errore RX USART\n\r");
				printf(" 2 = timeout RX USART\n\r");
				printf(" 3 = canale fuori range\n\r");
				printf(" 4 = protocollo fuori range\n\r");
				printf("\n\r================================================\n\r");
         		RCerr=('\n');	
         		break; 
         case 't':// test
         		printf("\n\n\r================================================\n\r");
         		RCerr=(0);	
         		break; 
         default:
                LedOff();
                return (1);	// canale fuori range		
         		break;
       }  
return (0);               
}

void RC6Header(char rpt)
// Generazione header RC6
{
/*					1			0
	Leader Pulse	2,667	0,889	6+2
	Start bit		0,444	0,444	1+1
	mode bit 2		0,444	0,444	1+1
	mode bit 1		0,444	0,444	1+1
	mode bit 0		0,444	0,444	1+1
	Trailer bit		0,889	0,889	2+2	1 if new key
*/
	unsigned char Cnt;
	unsigned char Mode;
	Mode = RC_MODE;
	LED_ON;	
	RC6Tick(6);		// Leader pulse 
	LED_OFF;
	RC6Tick(2);	
	MANCH_1;		// Start bit	

	for (Cnt = 0; Cnt < 3; Cnt++)		// 3 Mode bit
	{
		if (Mode & 0b00000100) 
		{
			MANCH_1;
		}
		else
		{
			MANCH_0;
		}
		Mode= Mode << 1;
	}
	
	if (rpt)		// Trailer bit.  lungo il doppio di un bit normale
	{				// se rpt = 1  una ripetizione del comando precedente
		LED_OFF;
		RC6Tick(2);
		LED_ON;
		RC6Tick(2);
	}
	else
	{
		LED_ON;
		RC6Tick(2);
		LED_OFF;
		RC6Tick(2);
	}
}
void RC6Dat(void)
{
	unsigned char Cnt;
	unsigned char Command;
	unsigned char Data;
	Command = RC_ADDR;
	Data = RC_DATA;
	
	for (Cnt = 0; Cnt < 8; Cnt++)
	{
		if (Command & 0b10000000) 
		{
			MANCH_1;
		}
		else
		{
			MANCH_0;
		}
		Command = Command << 1;
	}
	
	if (RC_PROT == 7)	// Sky
	{
		for (Cnt = 0; Cnt < 4; Cnt++)//  SKY: 4 bit aggiuntivi
		{
			MANCH_0;
		}
	}
	
	for (Cnt = 0; Cnt < 8; Cnt++)
	{
		if (Data & 0b10000000) 
		{
			MANCH_1;
		}
		else
		{
			MANCH_0;
		}
		Data = Data << 1;
	}
	

}
/*INTERRUPT==================================================================*/
// Low priority interrupt vector

#pragma code LowVector = 0x18

void InterruptVectorLow (void)
{
  _asm
    goto InterruptHandlerLow //jump to interrupt routine
  _endasm
}


// Low priority interrupt routine
#pragma code
#pragma interruptlow InterruptHandlerLow
/*IntServiceRoutine***************************************************/
void InterruptHandlerLow (void)

{  
	if (PIR1bits.RCIF) 
	{ 
		TMR0H = 0xFF - 0xE4;
		TMR0L = 0xFF - 0xE2;// carica il timer 1,5s
		INTCONbits.TMR0IF = 0;// reset flag di interrupt
		INTCONbits.TMR0IE=1;// interrupt TMR0 ON
		/*	
			legge
			RC_LED_NUM
			RC_PROT
			RC_DATA
		*/
		RCstring[RXpoint] = ReadUSART();
		if (USART_Status.FRAME_ERROR || USART_Status.OVERRUN_ERROR )
		{
			RCerr = 1;		//  errore RX USART
			RX_FLAG	= 1;	// terminata ricezione
			INTCONbits.GIEH=0;	// disabilita timer timeout
			return;	
		}
		RXpoint ++;
		if (RXpoint >= 4)
		{
			RX_FLAG	= 1;	// terminata ricezione
			INTCONbits.TMR0IE=0;// interrupt TMR0 OFF
		}
	}  	       
}   // Low Priority IntServiceRoutine
/*********************************************************************/

/*=======================================*/
// High priority interrupt vector
#pragma code HighVector = 0x08
void InterruptVectorHigh (void)
{
  _asm
    goto InterruptHandlerHigh //jump to interrupt routine
  _endasm
}


// High priority interrupt routine
#pragma code
#pragma interrupt InterruptHandlerHigh
/*IntServiceRoutine***************************************************/
void InterruptHandlerHigh (void)

{      
 if (INTCONbits.TMR0IF)   // l'interrupt e' stato generato dall'overflow del timer 0 ?
 {
	INTCONbits.TMR0IE=0;// interrupt TMR0 OFF
    INTCONbits.TMR0IF = 0;// reset flag di interrupt
    switch (RC_LED_NUM)
    {
	    case 'h':
	    	RCerr=0;
	    	break;
	    case 't':
	    	RCerr=0;
         	RC_TEST_FLAG = 1;	// test mode
	    	break;
	   	default:
		   RC_TEST_FLAG = 0;
		   RCerr = 2;		//  errore timeout RX
		   break;
	} 
    RX_FLAG	= 1;	//	terminata ricezione
 } 	
			
}  // High Priority IntServiceRoutine
/*********************************************************************/
/*INTERRUPT==================================================================*/

/* Fine funzioni **********************************************************************/
