/*
viene incluso in "wrc.c", contiene:
	definizioni
	prototipi funzioni
*/


/* Definizioni globali++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

//----- Status bits
#pragma config OSC = HSPLL			//	10 x 4 = 40MHZ
#pragma config WDT = OFF
#pragma config LVP = OFF
//	#pragma config PWRT = ON non compatibile con ICD2

//----- Definizione porte
#define INT1IF INTCON3bits.INT1IF 		// interrupt flag
#define INT2IF INTCON3bits.INT2IF 		// interrupt flag 
#define INT3IF INTCONbits.INT0IF		// interrupt flag

										// A0
										// A1
										// A2
										// A3 IR OUT 1				O
										// A4 IR OUT 2				O
										// A5 IR OUT 3				O
										// A6 OSC1
										// A7 OSC2
										// B0
										// B1
										// B2
#define LED1 PORTBbits.RB3				// B3 LED 					O
#define IR_IN PORTBbits.RB4				// B4 Ricevitore IR			I
#define RTS PORTBbits.RB5				// B5 Request To Send		I
										// B6 PGC (ICD2)
										// B7 PGD (ICD2)
										// C0 IR OUT 4				O
#define PWM PORTCbits.RC1				// C1 PWM 36KHz portante IR	O
										// C2 IR OUT 5				O
										// C3 SCL
										// C4 SDA
#define CTS PORTCbits.RC5				// C5 Clear To Send			O
										// C6 TX
										// C7 RX
										// D0 IR OUT 6				O
										// D1 IR OUT 7				O
										// D2 IR OUT 8				O
										// D3 IR OUT 9				O 
										// D4 IR OUT 10				O
										// D5 IR OUT 11				O
										// D6 IR OUT 12				O
										// D7 IR OUT 13				O
										// E0 IR OUT 14				O
										// E1 IR OUT 15				O
										// E2 IR OUT 16				O
										// E3 MCLR 

struct Bits{
	unsigned bit0:1;
	unsigned bit1:1;
	unsigned bit2:1;
	unsigned bit3:1;
	unsigned bit4:1;
	unsigned bit5:1;
	unsigned bit6:1;
	unsigned bit7:1;
};

struct Bits VARbits1;
extern union USART USART_Status;

//----- Flags
//#define  SPACE2RUN_FLAG VARbits1.bit1	// 

#define RC6Tick(x) (Delay1KTCYx(4*x),Delay100TCYx(4*x),Delay10TCYx(3*x))
#define	DELAY100MS Delay10KTCYx(100);	// 100ms

//----- Variabili
int i = 0; // contatore generico
int j = 0; // contatore generico
unsigned char a =0; // contatore generico

unsigned char *Port;	// puntatore alla porta che contiene il pin da gestire
unsigned char MaskOn;	// maschera per accendere il led collegato al pin
unsigned char MaskOff;	// maschera per spegnere il led collegato al pin
#define LED_OFF	*Port = *Port | MaskOff
#define LED_ON	*Port = *Port & MaskOn
// 0 e 1 in codifica Manchester
#define MANCH_0 (LED_OFF, RC6Tick(1), LED_ON,RC6Tick(1))
#define MANCH_1 (LED_ON, RC6Tick(1), LED_OFF,RC6Tick(1))

unsigned char RCstring[5];	

#define RC_LED_NUM RCstring[0]
#define RC_PROT RCstring[1]
#define RC_ADDR RCstring[2]
#define RC_DATA RCstring[3]
#define RC_MODE RCstring[4]

unsigned char RCerr;
#define RX_FLAG VARbits1.bit0
#define RC_TEST_FLAG VARbits1.bit1

unsigned char RXbuffer[64];	// buffer RX
unsigned char RXpoint;	// puntatore buffer RX seriale
	
/* Fine definizioni+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

/* Prototipi funzioni *****************************************************************/
void RCtest(void);

void RC(void);

void RC6Dat(void);

void RC6(void);

void LedOff(void);

unsigned char LedSelect(unsigned char LedNum);

void RC6Header(char rpt);

void InterruptHandlerHigh (void);

void InterruptHandlerLow (void);

/* Fine prototipi funzioni ***********************************************************/
