/*	
viene	incluso	in "wrc.c", contiene	i	settaggi del PIC
*/

/*Settings*****************************************************************************
															setting	di porte e registri
*/
void Settings(void)
{
	
//-------Port A
TRISA = 0b11000111;		
/*
RA0
RA1
RA2
RA3	IR Out 1
RA4	IR Out 2
RA5	IR Out 3
RA6	OSC 2
RA7	OSC 1
*/

//-------Port B
TRISB = 0b00110111;
INTCON2bits.RBPU;		// PORTB Pull-up enabled
/*
RB0	
RB1	
RB2	
RB3	LED		O
RB4	IR in	I
RB5	RTS		I
RB6	PGC		O
RB7	PGD		O
*/


//-------Port	C
TRISC = 0b10011000;
/*
RC0	IR out 4	O
RC1	PWM			O
RC2	IR out 5	O
RC3	
RC4	
RC5	CTS			O
RC6	TX			O
RC7	RX			I
*/

//-------Port D
TRISD	=	0b00000000;	
/*
RD0	IR out 6	O
RD1	IR out 7	O
RD2	IR out 8	O
RD3	IR out 9	O
RD4	IR out 10	O
RD5	IR out 11	O
RD6	IR out 12	O
RD7	IR out 13	O
*/


//-------Port	E
TRISE = 0b00000000;
/*
RE0	IR out 14
RE1	IR out 15
RE2	IR out 16
RE3	MCLR
*/


//-------A/D converter
ADCON1bits.PCFG3=0;	//	PCFG3:PCFG0	A/D	Port Configuration Control bits
ADCON1bits.PCFG2=1;	//	From AN0 to	AN7	Digital ports.
ADCON1bits.PCFG1=1;
ADCON1bits.PCFG0=0;

/*
ADCON1bits.VCFG1=0;	//	VCFG1:VCFG0 Voltage Reference Configuration bit (VREF-	source)	0=Vss
ADCON1bits.VCFG0=0;	//	Voltage	Reference	Configuration	bit	(VREF+ source) 0=Vdd
ADCON1bits.PCFG3=0;	//	PCFG3:PCFG0	A/D	Port Configuration Control bits
ADCON1bits.PCFG2=1;	//	From AN0 to	AN7	Analog ports.
ADCON1bits.PCFG1=1;	//	From A8	to AN12	Digital	ports.
ADCON1bits.PCFG0=1;
ADCON2bits.ADFM=0;	//	la lettura e' giustificata a sinistra, gli 8 bit piu' significativi sono
					//	in ADRESH gli ultimi 2 bit (che possono non essere utilizzati se sono
					//	sufficienti 256 livelli) sono i bit 7 e 6 di ADRESL
ADCON2bits.ADCS2=1;	//	ADCS2:ADCS0 A/D Conversion Clock Select bits
ADCON2bits.ADCS1=1;
ADCON2bits.ADCS0=1;
ADCON2bits.ACQT2=0;	//	ACQT2:ACQT0 A/D Acquisition Time
ADCON2bits.ACQT1=0;	//	ACQT2:ACQT0 = 000 Manual acquisition Time
ADCON2bits.ACQT0=0;	//	compatible with device without acquisition time.
ADCON0bits.ADON=1;	//	modulo A/D acceso
*/


//-------Interrupts
RCONbits.IPEN=1;		//	abilitata priorita' interrupt, non compatibile con 16fxx
INTCONbits.GIEH=0;		//	disabilitati tutti gli interrupt high
INTCONbits.GIEL=0;		//	disabilitati tutti gli interrupt low

T0CON = 0b10000111;
/*
TMR0ON	TMR0 acceso
T08BIT	Timer a 16 bit
T0CS	Timer on internal clock
TOSE	increment on low-to-high transition
PSA		Prescaler assegnato 256
*/

//-------Timer0
TMR0H -= 0xE4;
TMR0L -= 0xE2;
/*interrupt ogni 1,5 Sec 
  periodo = CLKOUT * prescaler * TMR0
  0.1mSec = 1/(40.000.000/4) * 256 * 58.594
*/

INTCONbits.TMR0IE=0;	//	interrupt on TMR0 overflow 
INTCON2bits.TMR0IP=1;	//	TMR0 interrupt high priority
IPR1bits.RCIP=0;		//	RX interrupt priority low

//-------USART
/*
bps		errore %   	SPBRG	
19200	0,16		129
38400	0,16		64
57600	0,93		42
115200	-1,35		21
230400	-1,35		10
*/

OpenUSART( USART_TX_INT_OFF &
USART_RX_INT_ON &
USART_ASYNCH_MODE &
USART_EIGHT_BIT &
USART_CONT_RX &
USART_BRGH_HIGH,
129 );

//-------PWM
CCP1CON=0b00001100;		//	ccpxm3:ccpxm0 11xx=pwm mode (compatible mode)
CCP2CON	=0b00001100;	//	ccpxm3:ccpxm0 11xx=pwm mode
T2CON	=	0X01;		//	STOP TIMER2 registers to POR state + prescaler = 4
PR2	=	0x44;			//	PWM freq = 36KHz @ 40 MHz
T2CONbits.TMR2ON = 1;	//	Turn on PWM
SetDCPWM2(0x8C);		//  PWM = 50%
//SetDCPWM2(0x55);		//  PWM = 30%

//-------I2C
/*
OpenI2C(MASTER, SLEW_OFF);	//	Master I2C, slew rate off per clock=100KHz
SSPADD=99;					//	100KHz baud clock @ 40MHz
							//	SSPAD=((Fosc/BitRate)/4)-1=(400/4)-1=99
PIE1bits.SSPIE=1;			//	SSP (I2C events) int enabled
PIE2bits.BCLIE=1;			//	BUS COLLISION int enabled
IPR1bits.SSPIP=0;			//	SSP int = low priority
IPR2bits.BCLIP=0;			//	BUS COLLISION int = low priority
*/

//-------Interrupts non usati
PIE1bits.TMR2IE=0;			//	interrupt on TMR2 overflow disabled
PIE1bits.TMR1IE=0;			//	interrupt on TMR1 overflow disabled
PIE2bits.TMR3IE=0;			//	interrupt on TMR3 overflow disabled
PIE1bits.PSPIE=0;			//	PSP int disabled
PIE1bits.ADIE=0;			//	AD int disabled
PIE1bits.CCP1IE=0;			//	CCP1 int disabled
PIE2bits.CCP2IE=0;			//	CCP2 int disabled
PIE2bits.EEIE=0;			//	EEPROM int disabled
PIE2bits.LVDIE=0;			//	LOW VOLTAGE int disabled
INTCONbits.INT0IE=0;	//	INT0
INTCON3bits.INT1IE=0;	//	INT1
INTCON3bits.INT2IE=0;	//	INT2



//-------Interrupts
/*
INTCON3bits.INT1IP=0;	//	INT1 bassa priorita'
INTCON3bits.INT2IP=0;	//	INT2 bassa priorita'
INTCON2bits.INTEDG0=0;	//	INT2 sul fronte di discesa
INTCON2bits.INTEDG1=1;	//	INT1 sul fronte di salita (se verso errato cambiare in 0)
INTCON2bits.INTEDG2=1;	//	INT2 sul fronte di salita
INTCONbits.RBIE=0;		//	interrupt on change PortB disabled
*/
		//INTCON3bits.INT1IF	//	interrupt on INT1
		//INTCON3bits.INT2IF	//	interrupt on INT2
		//INTCONbits.INT0IF		//	interrupt on INT0 
		//PIR1bits.TMR2IF		//	interrupt on TMR2 overflow
		//PIR1bits.TMR1IF		//	interrupt on TMR1 overflow
		//PIR1bits.PSPIF		//	PSP int
		//PIR1bits.ADIF			//	AD int
		//PIR1bits.RCIF			//	USART RXint
		//PIR1bits.TXIF			//	USART TX int
		//PIR1bits.SSPIF		//	SSP int 
		//PIR1bits.CCP1IF		//	CCP1 int 
		//PIR2bits.CCP2IF		//	CCP2 int 
		//PIR2bits.EEIF			//	EEPROM int
		//PIR2bits.BCLIF		//	BUS COLLISION int 
		//PIR2bits.LVDIF		//	LOW VOLTAGE int 
		//PIR2bits.TMR3IF		//	interrupt on TMR3 overflow

}
/*fine settings************************************************************************/
